#define EPSILON  0.001f
float4x4 tV : VIEW;
float4x4 tP : PROJECTION;
float4x4 tIVP : VIEWPROJECTIONINVERSE;

#include "StageStructs.fxh"
#include "VS.fxh"

float3 position;
float radius = 0.5f;

float spacing = 10.0f;

float sphere(float3 ray ,float3 center, float r)
{
	return distance(ray,center) - r;
}

float Distance(float3 p)
{
	float3 np = abs(p) % spacing - (spacing * 0.5f);
	float d = sphere(np,position,radius);
	return d;
}

float ray(float3 raypos,float3 raydir)
{
	raydir = normalize(raydir);

	float totaldist = 0.0f;
	float di = Distance(raypos);
	int iter = 0;
	for (iter = 0; iter < 100 && di > EPSILON && totaldist < 500;iter++)
	{
		raypos += raydir *di ;
		totaldist += di ;
		di=Distance(raypos);
	}	
	return iter * 0.01f;
}

 
float4 PS_Forward(psInput input) : SV_Target
{
	float3 raypos=input.raypos; 
 	float3 raydir=input.raydir;
	float p = ray(raypos,raydir);
	
	return p;
}



technique10 Render
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Forward() ) );
	}
}




